enum FREQUENCY{
    //%block="0.1"
    1,
    //%block="1.0"
    10,
    //%block="10.0"
    100
}


enum MUTE{
    //%block="静音"
    true,
    //%block="取消静音"
    false
}


enum MONO{
    //%block="单声道"
    true,
    //%block="立体声"
    false
}



enum UPDOWN{
    //%block="增加"
    Up,
    //%block="减少"
    Down
}


enum QUALITY{
    //%block="0"
    0,
    //%block="5"
    5,
    //%block="7"
    7,
    //%block="10"
    10
}





//% color="#0091ed" iconWidth=50 iconHeight=40
namespace TEA5765{
    //% block="TEA5767 Init" blockType="command"
    export function TEA5765Init(parameter: any, block: any) {
        Generator.addInclude('Arduino','#include <Arduino.h>');
        Generator.addInclude('Wire','#include <Wire.h>');
        Generator.addInclude('radio','#include <radio.h>');
        Generator.addInclude('TEA5765','#include <TEA5767.h>'); 
        Generator.addObject(`radioObj`, `TEA5767`, `radio;`);
        Generator.addSetup(`radio.init`, `radio.init();`);
        Generator.addSetup(`radio.setMono`, `radio.setMono(true);`);
    }
   
    
    //% block="set Frequency[FREQUENCY]" blockType="command"
    //% FREQUENCY.shadow="range" FREQUENCY.params.min=87.6 FREQUENCY.params.max=108 FREQUENCY.defl=91.6
    export function SetFreq(parameter: any, block: any) {
        let frequency = parameter.FREQUENCY.code * 100;
        Generator.addCode(`radio.set_Frequency(${frequency});`);
    }


    //% block="[UPDOWN]Frequency[CHANGE]" blockType="command"
    //% UPDOWN.shadow="dropdown" UPDOWN.options="UPDOWN"
    //% CHANGE.shadow="range" CHANGE.params.min=0.1 CHANGE.params.max=10 CHANGE.defl=1
    export function UpdownFreq(parameter: any, block: any) {
        let updown = parameter.UPDOWN.code;      
        let change = parameter.CHANGE.code * 100;
        if(updown=='Up')
            Generator.addCode(`radio.Change_Frequency(${change});`);
        else
            Generator.addCode(`radio.Change_Frequency(-${change});`);   
    }

    
    //% block="Get Frequency" blockType="reporter"
     export function GetFreq(parameter: any, block: any) {
        Generator.addCode(`radio.getFrequency()*0.01`);
    }


    //% block="Set Mute[MUTE] Mode" blockType="command"
    //% MUTE.shadow="dropdown" MUTE.options="MUTE"
    export function SetMute(parameter: any, block: any) {
        let mute =  parameter.MUTE.code; 
        Generator.addCode(`radio.setMute(${mute});`);
    }


    //% block="Set Mono[MONO] Mode" blockType="command"
    //% MONO.shadow="dropdown" MONO.options="MONO"
    export function SetMono(parameter: any, block: any) {
        let mono =  parameter.MONO.code; 
        Generator.addCode(`radio.setMono(${mono});`);
    }

}
