enum FREQUENCY{
    //%block="0.1"
    1,
    //%block="1.0"
    10,
    //%block="10.0"
    100
}


enum MUTE{
    //%block="静音"
    True,
    //%block="取消静音"
    False
}


enum STANSBY{
    //%block="待机"
    True,
    //%block="取消待机"
    False
}



enum DIRECTION{
    //%block="向上"
    1,
    //%block="向下"
    0
}


enum UPDOWN{
    //%block="增加"
    Up,
    //%block="减少"
    Down
}


enum QUALITY{
    //%block="0"
    0,
    //%block="5"
    5,
    //%block="7"
    7,
    //%block="10"
    10
}



//% color="#0091ed" iconWidth=50 iconHeight=40
namespace TEA5765{
    //% block="TEA5767 Init" blockType="command"
    export function TEA5765Init(parameter: any, block: any) {
        Generator.addImport("from mpython import *");
        Generator.addImport("from machine import I2C,Pin");    
        Generator.addImport("from TEA5767 import Radio");
        Generator.addCode(`radio = Radio(i2c, freq=91.6)`);    
    }


    //% block="set Frequency[FREQUENCY]" blockType="command"
    //% FREQUENCY.shadow="range" FREQUENCY.params.min=87.6 FREQUENCY.params.max=108 FREQUENCY.defl=91.6
    export function SetFreq(parameter: any, block: any) {
        let frequency = parameter.FREQUENCY.code;
        Generator.addCode(`radio.set_frequency(${frequency})`);
    }

    //% block="[UPDOWN]Frequency[CHANGE]" blockType="command"
    //% UPDOWN.shadow="dropdown" UPDOWN.options="UPDOWN"
    //% CHANGE.shadow="range" CHANGE.params.min=0.1 CHANGE.params.max=10 CHANGE.defl=1
    export function UpdownFreq(parameter: any, block: any) {
        let updown = parameter.UPDOWN.code;      
        let change = parameter.CHANGE.code;
        if(updown=='Up')
            Generator.addCode(`radio.change_freqency(${change});`);
        else
            Generator.addCode(`radio.change_freqency(-${change});`);   
    }
    

    //% block="Manual Search[DIRECTION][QUALITY]" blockType="command"
    //% DIRECTION.shadow="dropdown" DIRECTION.options="DIRECTION"
    //% QUALITY.shadow="dropdown" QUALITY.options="QUALITY" QUALITY.defl="QUALITY.7"
    export function ManualSearch(parameter: any, block: any) {
        let direction = parameter.DIRECTION.code;
        let quality = parameter.QUALITY.code; 
        Generator.addCode(`radio.search(True,dir=${direction},adc=${quality})`);
    }

    
    //% block="Get Frequency" blockType="reporter"
     export function GetFreq(parameter: any, block: any) {
        Generator.addCode(`round(radio.get_freqency(),1)`);
    }


    //% block="Mute[Mute]" blockType="command"
    //% Mute.shadow="dropdown" Mute.options="Mute"
    export function Mute(parameter: any, block: any) {
        let mute =  parameter.Mute.code; 
        Generator.addCode(`radio.mute(${mute})`);
    }

    //% block="Standby[STANSBY]" blockType="command"
    //% STANSBY.shadow="dropdown" STANSBY.options="STANSBY"
    export function Standby(parameter: any, block: any) {
        let standby =  parameter.STANSBY.code;
        Generator.addCode(`radio.standby(${standby})`);
    }

    //% block="Mute[MUTE]" blockType="command"
    //% MUTE.shadow="dropdown" MUTE.options="MUTE" MUTE.defl="MUTE.1"
    export function Mute(parameter: any, block: any) {
        let mute =  parameter.MUTE.code; 
        Generator.addCode(`radio.mute(${mute})`);
    }

    //% block="Standby[STANSBY]" blockType="command"
    //% STANSBY.shadow="dropdown" STANSBY.options="STANSBY" STANSBY.defl="STANSBY.1"
    export function Standby(parameter: any, block: any) {
        let stansby =  parameter.STANSBY.code;
        Generator.addCode(`radio.standby(${stansby})`);
    }

}
